#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <complex>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = n - 1; i >= 0; i --)
#define fs first
#define sc second
#define all(a) a.begin(), a.end()
#define last(a) (int)a.size() - 1
#define pb push_back
#define mp make_pair
#define seta(x,y) memset (x, y, sizeof (x))
#define I (int)
#define y0 botva
#define y1 hui

typedef long long int64;
typedef pair <int, int> pii;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const int64 inf64 = (1LL << 62) - 1;
const ldb pi = acos(-1.);

template <class T> T sqr (const T &a) {return a * a;}

World *world;
double alpha;
double x, y;
double r, x0, y0;
const double dx[4] = {1, 0, -1, 0};
const double dy[4] = {0, 1, 0, -1};
int cur;
int iter;
int pdst;
vector < pair <double, double> > Q;

bool check (CMonster &A);

void init () {
	pdst = -1000;
	cur = 0;
	r = 0.15;
	x0 = 0.2;
	y0 = 0.2;
	alpha = 0;
	iter = 0;
	x = x0 + cos(alpha) * r;
	y = y0 + sin(alpha) * r;
	Q.clear ();
}

void move_old () {
	double d = world->player.MaxVelocity;
	alpha += 0.02;
	double cf = 0.0025;
	x0 += dx[cur] * cf;
	y0 += dy[cur] * cf;
	iter ++;
	if (iter >= I (0.6 / cf + 1e-9))
	{
		iter = 0;
		cur = (cur + 1) % 4;
	}
	x = x0 + cos(alpha) * r;
	y = y0 + sin(alpha) * r;
//	cerr << " " << x << " " << y << " " << x0 << " " << y0 << endl;
	world->run (x - world->player.PositionX, y - world->player.PositionY);
}

void move__ () {
	double d = world->player.MaxVelocity;
	double best = -1;
	double bests = -1e100;
	int cur = 0;
	pdst = 60 - pdst;
	Q.pb (mp (world->player.PositionX, world->player.PositionY));
	forn (i, 60)
	{
//		int d1 = min (abs (pdst - i), abs (pdst - i - 60));
//		if (d1 <= 10)
//			continue;
		double alf = (i * 2. * pi / 60.);
		double x = world->player.PositionX + cos(alf) * 0.2;
		double y = world->player.PositionY + sin(alf) * 0.2;
		double X = world->player.PositionX + cos(alf) * 0.001;
		double Y = world->player.PositionY + sin(alf) * 0.001;
		bool ok = 1;
		forn (j, 20)
		{
			int pos = Q.size() - j - 1;
			if (pos >= 0)
				if (sqrt (sqr (X - Q[pos].fs) + sqr (Y - Q[pos].sc)) < 0.01)
					ok = 0;
		}
		if (!ok)
			continue;
		if (X < 0.03 || Y < 0.03 || X > 0.97 || Y > 0.97)
			continue;
		double s = 1e100;
		forn (j, world->MAXMONSTERS)
			if (check(world->monsters[j])) {
				s = min(s, sqrt (sqr (x - world->monsters[j].PositionX) + sqr (y - world->monsters[j].PositionY)));
			}
		if (bests < s)
		{
			bests = s;
			best = alf;
			cur = i;
		}
	}
	pdst = cur;
	world->run (cos(best), sin(best));
}

void move () {
	double d = world->player.MaxVelocity;
	double best = -1;
	double bests = -1e100;
	int cur = 0;
	Q.pb (mp (world->player.PositionX, world->player.PositionY));
//	cerr << Q[last(Q)].fs << " " << Q[last(Q)].fs << endl;
//	if (Q.size() > 1)
//		cerr << sqrt (sqr (Q[last(Q)].fs - Q[last(Q)-1].fs) + sqr (Q[last(Q)].sc - Q[last(Q)-1].sc)) << endl;
	forn (i, 60)
	{
		double alf = (i * 2. * pi / 60.);
		double x = world->player.PositionX + cos(alf) * 0.2;
		double y = world->player.PositionY + sin(alf) * 0.2;
		double X = world->player.PositionX + cos(alf) * 0.0025;
		double Y = world->player.PositionY + sin(alf) * 0.0025;
		bool ok = 1;
		forn (j, 10)
		{
			int pos = Q.size() - j - 1;
			if (pos >= 0)
				if (sqrt (sqr (X - Q[pos].fs) + sqr (Y - Q[pos].sc)) < 0.0001)
					ok = 0;
		}
		if (!ok)
			continue;
		if (x < 0 || y < 0 || x > 1 || y > 1)
			continue;
		double s = 1e100;
		forn (j, world->MAXMONSTERS)
			if (check(world->monsters[j])) {
				s = min(s, sqrt (sqr (x - world->monsters[j].PositionX) + sqr (y - world->monsters[j].PositionY)));
			}
		if (bests < s)
		{
			bests = s;
			best = alf;
			cur = i;
		}
	}
/*	if (bests < 0.0)
	{
		cur = pdst;
		best = (cur * 2. * pi / 60.);
	}*/
	world->run (cos(best), sin(best));
}

void moveOO () {
	double d = world->player.MaxVelocity;
	double best = -1;
	double bests = -1e100;
	int cur;
	pdst = 60 - pdst;
	forn (i, 60)
	{
		int d = min (abs (pdst - i), abs (pdst - i - 60));
		if (d <= 10)
			continue;
		double alf = (i * 2. * pi / 60.);
		double x = world->player.PositionX + cos(alf) * 0.2;
		double y = world->player.PositionY + sin(alf) * 0.2;
		if (x < 0.03 || y < 0.03 || x > 0.97 || y > 0.97)
			continue;
		double s = 1e100;
		forn (j, world->MAXMONSTERS)
			if (check(world->monsters[j])) {
				s = min(s, sqrt (sqr (x - world->monsters[j].PositionX) + sqr (y - world->monsters[j].PositionY)));
			}
		if (bests < s)
		{
			bests = s;
			best = alf;
			cur = i;
		}
	}
	pdst = cur;
	world->run (cos(best), sin(best));
}

pair <double, double> ShootMonster (CMonster &A) {
	double x0 = world->player.PositionX;
	double y0 = world->player.PositionY;
	double x1 = A.PositionX;
	double y1 = A.PositionY;
	double vx = A.VelocityX;
	double vy = A.VelocityY;
	double x = x0 - x1;
	double y = y0 - y1;
	double v = world->player.BulletVelocity;
	double b = x * v;
	double a = - y * v;
	double c = (x * vy - y * vx);
	double D = sqrt (a * a + b * b);
	a /= D;
	b /= D;
	c /= D;
	double phi = acos (a);
	if (fabs (sin(phi) - b) > 1e-7)
		phi = -phi;
	double alp = acos(c) + phi;
	double t = x / (vx - v * cos(alp));
	if (t < 0)
		alp = -acos(c) + phi;
//	cerr << x0 << " " << y0 << " " << v << " " << x1 << " " << y1 << " " << vx << " " << vy << endl;
//	cerr << t << " " << alp << endl;
//	cerr << x0 + v * cos(alp) * t << " " << y0 + v * sin(alp) * t << " " << x1 + vx * t << " " << y1 + vy * t << endl;
	return (mp (cos (alp), sin (alp)));
}

bool check (CMonster &A)
{
	if (A.ClassName < 0)
		return 0;
	if (A.PositionX < 0 || A.PositionX > 1 || A.PositionY < 0 || A.PositionY > 1)
		return 0;
	return 1;
}

void shoot () {
	int num = -1;
	vector <int> a;
	double dbest = 1e100;
	vector < pair <double, int> > scores, tmp;
	for (int j = 0; j < world->MAXMONSTERS; j++)
		if (check (world->monsters[j])) {
			double x0 = world->player.PositionX + world->player.VelocityX * 0.01;
			double y0 = world->player.PositionY + world->player.VelocityY * 0.01;
			double x1 = world->monsters[j].PositionX + world->monsters[j].VelocityX * 0.01;
			double y1 = world->monsters[j].PositionY + world->monsters[j].VelocityY * 0.01;
			double d = sqr (x0 - x1) + sqr (y0 - y1);
			scores.pb (mp (d, j));
		}
	if (scores.size() == 0)
		return;
	sort (all (scores));
	int x = 0;
	if (scores.size() < 10)
		x = rand() % scores.size();
	pair <double, double> res;
	tmp = scores;
	if (scores[0].fs < 0.1)
		res = ShootMonster (world->monsters[scores[x].sc]);
	else
	{
		int i = 0;
		while (i < I scores.size())
			if (world->monsters[scores[i].sc].BulletDamage == 0)
			{
				swap (scores[i], scores[last(scores)]);
				scores.pop_back();
			}
			else
				i ++;
		if (scores.size() == 0)
			res = ShootMonster (world->monsters[tmp[x].sc]);
		else
			res = ShootMonster (world->monsters[scores[rand() % scores.size()].sc]);
	}

//	cerr << dbest << endl;
//	cerr << world->player.PositionX << " " << world->player.PositionY << endl;
//	cerr << world->monsters[num].PositionX << " " << world->monsters[num].PositionY << endl;
//	cerr << world->player.Time << endl;	
//	cerr << endl;
	world->shoot(res.fs, res.sc);
}

void solve () {
	move ();
	shoot ();

	
}

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}
//	freopen ("log.txt", "w", stderr);
	
	world = new World(argv[1], atoi(argv[2]));
	init ();

	while (true) {
		world->makeMove();

		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);

		solve ();
	}

	return 0;
}
