#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <vector>
using namespace std;
#define PI  3.1415926535897932384626433832795
#define sqr(x) (x) * (x)

World *w;
float alpha = 0.0;
float eps = 1e-5;

int selid;
bool selected = false;

float deadangle = 0.7;
float shoftangle = PI/8;

float incspeed = 1.0012;
float decspeed = 1.0012;
float sp = 0.03;
bool in = false;

float dist(float x, float y)
{
	return sqr(x - w->player.PositionX) + sqr(y - w->player.PositionY);
}

pair<float, float> find(int k)
{
	float min = 0;
	float max = 1000;
	float t = max / 2;
	float s;
	float Px = w->monsters[k].PositionX - w->player.PositionX;
	float Py = w->monsters[k].PositionY - w->player.PositionY;
	float vx = w->monsters[k].VelocityX;
	float vy = w->monsters[k].VelocityY;
	float b = w->player.BulletVelocity;
	while (fabs(s = sqrt(  sqr( Px/t + vx ) + sqr( Py / t + vy) )-b) >= eps)
	{
		if (s > 0)
			min = t;
		else
			max = t;
		t = (min + max) / 2;
	}
	return make_pair( Px + vx * t, Py + vy * t);
}

bool insector(int k)
{
	float px = w->player.RunX * cos(shoftangle) - w->player.RunY * sin(shoftangle);
	float py = w->player.RunX * sin(shoftangle) + w->player.RunY * cos(shoftangle);
	float mx = w->monsters[k].PositionX - w->player.PositionX;
	float my = w->monsters[k].PositionY - w->player.PositionY;
	float cs = (px * mx + py * my) / sqrt(sqr(px) + sqr(py)) / sqrt(sqr(mx) + sqr(my));
	return cs > deadangle;
}
int monsters()
{
	int ans = 0;
	for ( int j = 0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0)
			ans++;
	return ans;
}

bool many=true, few=false, th=false;
void run()
{
	w->run(cos(alpha), sin(alpha));
}

float dist(CMonster* mons)
{
	return sqr(mons->PositionX - w->player.PositionX) + sqr(mons->PositionY - w->player.PositionY);
}

int getnear()
{
	int selid = -1;
	for ( int j = 0; j < w->MAXMONSTERS; j++)
			if (w->monsters[j].ClassName >= 0 && insector(j)) 
			{
				selid = j;
				break;
			}
	if (selid != -1)
	{
		for ( int j = selid + 1; j < w->MAXMONSTERS; j++)
			if (w->monsters[j].ClassName >= 0) 
				if (dist(&w->monsters[j]) < dist(&w->monsters[selid]) && insector(j))
					selid = j;
		return selid;
	}
	for ( int j = 0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0) 
		{
			selid = j;
			break;
		}
	for ( int j = selid + 1; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0) 
			if (dist(&w->monsters[j]) < dist(&w->monsters[selid]))
				selid = j;
	return selid;
}

int selectmonster()
{
	return getnear();
	if (selected)
	{
		if (w->monsters[selid].ClassName != -1)
			return selid;
		selected = false;
		return selectmonster();
	}
	selected = true;

	for ( int j = 0; j < w->MAXMONSTERS; j++)
			if (w->monsters[j].ClassName >= 0) 
			{
				selid = j;
				break;
			}
	for ( int j = selid + 1; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0) 
			if (w->monsters[j].HitPoints < w->monsters[selid].HitPoints)
				selid = j;
	return selid;
}
void shoot(int k)
{
	pair<float, float> b = find(k);
	w->shoot(b.first, b.second);
}


int main(int argc, char** argv)
{
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	w = new World(argv[1], atoi(argv[2]));
	
	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		w->makeMove();

		//Print some information
		//printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf in:%d\n", w->player.Time, w->player.HitPoints, w->player.PositionX, w->player.PositionY, in);
		if (in)
			sp *= decspeed;
		else
			sp /= incspeed;
		alpha += sp;// 0.01;
		if (dist(0.5, 0.5) < 0.01)
			in = false;
		if (fabs(w->player.PositionX - 0.5f) > 0.4f || fabs(w->player.PositionY -0.5f) > 0.4f)
			in = true;
		//Run in circles (set direction)
		run();

		//Choose the first monster that is still alive
		shoot(selectmonster());
	}

	return 0;
}

