#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
struct Sect {
	double left, right;
};
double pi = 3.141592653589;

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	World *world = new World(argv[1], atoi(argv[2]));
	float alpha = 0.0;
	int step = 0, copyj = 1;
	int sector[10] = {0};
	Sect masSect[10];
	double sh = pi / 5;

	masSect[0].left = 0;
	masSect[0].right = sh;
	for (int i = 1; i < 10; i++) {
		masSect[i].left = masSect[i - 1].right;
		masSect[i].right = masSect[i].left + sh;
	}


	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		world->makeMove();

		if  (true) {
			for (int i = 0; i < world->MAXMONSTERS; i++) {
				if (world->monsters[i].ClassName >= 0) {
				double angle = atan((world->monsters[i].PositionY - 0.5) / (world->monsters[i].PositionX - 0.5));

				for (int j = 0; j < 10; j++)
					if ( (angle >= masSect[j].left) && (angle <= masSect[j].right) ) {
						sector[j]++;
						break;
					}
				}
			}
			int min = 100000;
			for (int j = 0; j < 10; j++) {
				if (sector[j] < min) {
					min = sector[j];
					copyj = j;
				}
			}
		}

		if ((step < 130))
			alpha = (masSect[copyj].right + masSect[copyj].left) / 2;
		else
			if (step < 940) alpha +=0.01; else {
				if ((step > 940)&&(step < 1250))alpha = 0;
				if (step > 1250)
					alpha -= 0.01;
			}

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);


		//Run in circles (set direction)
		world->run(cos(alpha), sin(alpha));
	
		double rast = 100;
		int target = 1;

		//Choose the first monster that is still alive
		for ( int j = 0; j < world->MAXMONSTERS; j++)
			if (world->monsters[j].ClassName >= 0) {
				double curr = (world->monsters[j].PositionX - world->player.PositionX)*(world->monsters[j].PositionX - world->player.PositionX) + (world->monsters[j].PositionY - world->player.PositionY)*(world->monsters[j].PositionY - world->player.PositionY);
				if (  curr < rast ) {
					rast = curr;
					target = j;
				}
				//Shoot the bastard! (Shoot in the direction of the monster)
			}
			world->shoot(world->monsters[target].PositionX - world->player.PositionX,
						   world->monsters[target].PositionY - world->player.PositionY);
	/*	for (int i = 0; i < world->MAXMONSTERS; i++) {
				if (world->monsters[i].ClassName >= 0) {
				double angle = atan((world->monsters[i].PositionY - 0.5) / (world->monsters[i].PositionX - 0.5));

				
				if ( (angle >= masSect[copyj].left) && (angle <= masSect[copyj].right) ) {
						world->shoot(world->monsters[i].PositionX - world->player.PositionX, world->monsters[i].PositionY - world->player.PositionY);
						break;
					}
				}
			}*/
		step++;
	}

	return 0;
}
