#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <cassert>
#include <vector>
#include <algorithm>

using namespace std;

typedef double dbl;

typedef pair <dbl, dbl> pnt;

#define x first
#define y second


#define en_p(id) (pnt(world->monsters[id].PositionX, world->monsters[id].PositionY)) 

World *world;
int level = 0;
int now;
int prev_shoot;
pnt prev_p;
pnt my_p;
dbl bv;
int state = 0;

pnt operator - (pnt a, pnt b) {return pnt (a.x - b.x, a.y - b.y);}
pnt operator + (pnt a, pnt b) {return pnt (a.x + b.x, a.y + b.y);}
dbl operator * (pnt a, pnt b) {return a.x * b.y - a.y * b.x;}
dbl operator % (pnt a, pnt b) {return a.x * b.x + a.y * b.y;}
pnt operator * (pnt a, dbl d) {return pnt (a.x * d, a.y * d);}
dbl d (pnt a) {return hypot(a.x, a.y);}

struct monster {
  int type;
  pnt p, v;
  dbl r;
  dbl hp;
  dbl mx_hp;
  dbl mx_v;
  dbl mx_acc;
  dbl GunCooldownRemaining;
  dbl GunCooldownPeriod;
  dbl bull_dmg;
  dbl bull_hp;
  dbl bull_v;
  dbl bull_r;
  dbl TeethCooldownRemaining;
  dbl TeethCooldownPeriod;
  dbl bite_dmg;

  int shoot_cnt;
  int upd_t;

  monster (void) {
    type = -1;
  }

  void upd (CMonster m) {
    if (type != m.ClassName || hp > m.HitPoints) {
      shoot_cnt = 0;
      upd_t = 0;
    }

    type = m.ClassName;
    p = pnt(m.PositionX, m.PositionY);
    v = pnt(m.VelocityX / 60, m.VelocityY / 60);
    r = m.Radius;
    hp = m.HitPoints;
    mx_hp = m.MaxHitPoints;
    mx_v =  m.MaxVelocity;
    mx_acc = m.MaxAcceleration;
    GunCooldownRemaining = m.GunCooldownRemaining;
    GunCooldownPeriod = m.GunCooldownPeriod;
    bull_dmg = m.BulletDamage;
    bull_hp =  m.BulletHitPoints;
    bull_v = m.BulletVelocity;
    bull_r = m.BulletRadius;
    TeethCooldownRemaining = m.TeethCooldownRemaining;
    TeethCooldownPeriod = m.TeethCooldownPeriod;
    bite_dmg = m.BiteDamage;

    if (now >= upd_t/* && level != 1*/) {
      shoot_cnt = 0;
    }
  }

  bool can_shoot () {
    if (1 || world->player.GunCooldownRemaining < 1.0 / 59 + 1e-9) {
      return type != -1 && hp > (shoot_cnt -  3) * world->player.BulletDamage;
    } else {
      return false;
    }
  }

  bool can_shoot2 () {
    if (type == 104) {
      return type != -1 && shoot_cnt <= 1;
    } else {                      
      return false;
    }
  }
};

vector <monster> en;

void upd_level (void) {
  if (level == 0 && now > 1800) {
    level = 1;
  } else if (level == 1 && now > 3150) {
    int f = 1;
    for (int i = 0; i < (int)en.size(); i++) {
      if (en[i].type == 104) {
       f = 0;
      }
    }
    if (f && my_p.x >= 0.45 || my_p.x >= 0.55) {
      level = 2;
      state = 1;
    }
  }
}


int find_monster_closest (int f = 0);

void shoot (int id) {
  if (prev_shoot != -1 && en[prev_shoot].can_shoot()) {
    id = prev_shoot;
  }

  int cid = find_monster_closest ();
  if (cid != -1 && d(my_p - en[cid].p) < 0.05) {
    id = cid;
  }


  if (id == -1) {
    return;
  }

  en[id].shoot_cnt++;
//  //fprintf (stdout, "now = %d, id = %d, shoot_cnt = %d\n", now, id, en[id].shoot_cnt);
  int ex = now + (int)ceil(d(en[id].p - my_p) / bv); 
//  //fprintf (stdout, "exp = %d\n", ex);
  if (en[id].upd_t < ex) {
    en[id].upd_t = ex;
  }
  prev_shoot = id;
  
  world->shoot(en[id].p.x - my_p.x, en[id].p.y - my_p.y);
}

void shoot2 (int id) {
  pnt p;
  if (id != -1) {
    //fprintf (stdout, "now = %d, id = %d, shoot_cnt = %d\n", now, id, en[id].shoot_cnt);
    //fflush (stdout);
  } else {
    //fprintf (stdout, "shoot2\n");
    //fflush(stdout);
  }

  
  if (world->player.GunCooldownRemaining > 1e-9) {
    //fprintf (stdout, "end shoot2\n");
    //fflush(stdout);
    return;
  }

  if (prev_shoot != -1 && en[prev_shoot].can_shoot2 ()) {
    id = prev_shoot;
    p = prev_p;
  } else {
    if (id == -1) {
      prev_shoot = -1;
      //fprintf (stdout, "end shoot2\n");
      //fflush(stdout);
      return;
    }
/*    int t;
    pnt m;
    for (t = 0; t < 30; t++) {
      m = en[id].p + en[id].v * (t / 60.0);
      dbl x = d(my_p - m) / bv;
      if (x < t + 1e-9) {
        break;
      }
    }
    if (t == 30) {
      return;
    }
    p = m;*/

    double mv = en[id].v % en[id].v;
    pnt dir = en[id].p - my_p;
    double A = bv * bv - mv, B = -2 * (en[id].v % dir), C = - (dir % dir);
    double D = B * B - 4 * A * C;

    if (D < 0) {
    //fprintf (stdout, "end shoot2 !!!!!!!!!!!!!!!!!!!!!!!!!!\n");
    //fflush(stdout);
      return;
    }

    D = sqrt (D);
    double a = (-B + D) / (2 * A);
    if (a < 0) {
    //fprintf (stdout, "end shoot2 @@@@@@@@@@@@@@@@@@@@@@@@\n");
    //fflush(stdout);
      return;
    }

    p = en[id].p + en[id].v * a;
  }

  //fprintf (stdout, "!!!!!!%d\n", en[id].type);
  //fflush (stdout);

  en[id].shoot_cnt++;
  int ex = now + (int)ceil(d(p - my_p) / bv) + 3; 
  if (en[id].upd_t < ex) {
    en[id].upd_t = ex;
  }

  prev_shoot = id;
  prev_p = p;
  
  world->shoot(p.x - my_p.x, p.y - my_p.y);
    //fprintf (stdout, "end shoot2\n");
    //fflush(stdout);
}


int find_monster_closest (int f) {
  int besti = -1;
  dbl bestd = 0;

  for (int i = 0; i < (int)en.size(); i++) {
    if (en[i].can_shoot() || f && en[i].type >= 0) {
      dbl curd = d(en[i].p - my_p);
      if (besti == -1 || curd < bestd) {
        besti = i;
        bestd = curd;
      }
    }
  }

  if (besti == -1 && !f) {
    return find_monster_closest (1);
  }

  return besti;
}

int find_monster_closest2 (int f = 0) {
  int besti = -1;
  dbl bestd = 0;

  //fprintf (stdout, "enter %d\n", f);
  //fflush (stdout);

  for (int i = 0; i < (int)en.size(); i++) {
    if (en[i].can_shoot2() || f && en[i].type >= 0) {
      dbl curd = en[i].GunCooldownRemaining;
      if (besti == -1 || curd < bestd) {
        besti = i;
        bestd = curd;
      }
    }
  }

  if (besti == -1 && !f) {
    return find_monster_closest2 (1);
  }

  return besti;
}


int find_monster_in_dir (pnt dir) {
  int besti = -1;
  dbl bestd = 0;
  for (int i = 0; i < (int)en.size(); i++) {
    if (en[i].can_shoot()) {
      if ((en[i].p - my_p) % (dir) > 0) {
        dbl curd = fabs((en[i].p - my_p) * (dir));
        if (besti == -1 || curd < bestd) {
          besti = i;
          bestd = curd;
        }
      }
    }
  }

  if (besti != -1) {
    return besti;
  }

  return find_monster_closest();
}

void shoot_level_1 (void) {
  int id = find_monster_closest2();
  //fprintf (stdout, "fnd %d\n", id);
  //fflush (stdout);
  shoot2 (id);
}

void run (int f = 1) {
//  fprintf (stdout, "%d\n", state);
  while (true) {
    if (state == 0) {
      if (my_p.x > 0.9) {
        state = 1;
        continue;
      }
      if (f)
        shoot (find_monster_in_dir (pnt (1, 0)));
      world->run (1, 0);
      break;
    } else if (state == 1) {
      if (my_p.y > 0.9) {
        state = 2;
        continue;
      }
      if (f)
        shoot (find_monster_in_dir (pnt (0, 1)));
      world->run (0, 1);
      break;
    } else if (state == 2) {
      if (my_p.x < 0.2 - level * 0.09) {
        state = 3;
        continue;
      }
      if (f)
        shoot (find_monster_in_dir (pnt (-1, 0)));
      world->run (-1, 0);
      break;
    } else if (state == 3) {
      if (my_p.y < 0.2) {
        state = 4;
        continue;
      }
      if (f)
        shoot (find_monster_in_dir (pnt (0, -1)));
      world->run (0, -1);
      break;
    } if (state == 4) {
      if (my_p.x > 0.5) {
        state = 5;
        continue;
      }
      if (f)
        shoot (find_monster_in_dir (pnt (1, 0)));
      world->run (1, 0);
      break;
    } else if (state == 5) {
      if (my_p.y > 0.6) {
        state = 0;
        continue;
      }
      if (f)
        shoot (find_monster_in_dir (pnt (1, 1)));
      world->run (1, 1);
      break;
    }   
  } 

/*
  //Choose the first monster that is still alive
  for ( int j = 0; j < world->MAXMONSTERS; j++) {
    if (world->monsters[j].ClassName >= 0) {
      //Shoot the bastard! (Shoot in the direction of the monster)
      world->shoot(world->monsters[j].PositionX - world->player.PositionX,
             world->monsters[j].PositionY - world->player.PositionY);
      break;
    }
  }*/
}

int main (int argc, char** argv) {
  //Check for enough parameters
  if (argc < 3) {
    //fprintf(stderr, "Parameters: IP port\n");
    return 10;
  }

  //Create the world data (and establish connection with the server)
  world = new World(argv[1], atoi(argv[2]));

  en.resize (world->MAXMONSTERS);
  prev_shoot = -1;

//  freopen ("my_log", "w", stdout);

  //Infinite loop
  while (true) {
    //Send our turn and receive the update of the game world
    //fprintf (stdout, "\n\nNEW TURN\n");
    //fflush (stdout);
    world->makeMove();
    now = world->player.Time;
    for (int i = 0; i < world->MAXMONSTERS; i++) {
      en[i].upd (world->monsters[i]);
    }
    my_p = pnt(world->player.PositionX, world->player.PositionY);
    bv = world->player.BulletVelocity / 60.;

    //Print some information
/*    printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf | %lf, level = %d\n",
        world->player.Time, world->player.HitPoints,
        world->player.PositionX, world->player.PositionY, world->player.GunCooldownPeriod, level);*/
    //fflush (stdout);
    
    upd_level();

    switch (level) {
      case 0:
        run();
        break;
      case 1:
        run(0);
        //fprintf (stdout, "chose closest");
        //fflush (stdout);
        shoot_level_1();
        break;
      case 2:
        run();
        break;
      default:
        assert (0);
    }
  }

  return 0;
}
