#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <vector>

using namespace std;

const double Pi=3.1415926;
const double pi=Pi;
double getangle(double x, double y){
    if (y>=0) return acos(x/sqrt(x*x+y*y)); else
    return Pi+acos(-x/sqrt(x*x+y*y));
}
void norm(double&x,double&y){
    double hui=sqrt(x*x+y*y);
    if (hui!=0) {
        x/=hui;
        y/=hui;
    }
}
double sqr(double hui) { return hui*hui; }
int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	World *world = new World(argv[1], atoi(argv[2]));
	float alpha = 0.0;
double rad=0.4;
double radalpha=0;
int wave=0;
vector<int> prerost(10);
	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		world->makeMove();

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);

		//Run in circles (set direction)
		double trxx=world->player.PositionX-0.5;
		double tryy=world->player.PositionY-0.5;
        double wlen=sqrt(trxx*trxx+tryy*tryy);
        if (wlen==0) {alpha=0; trxx=1;} else {
            trxx/=wlen;
            tryy/=wlen;
            trxx*=(rad-wlen);
            tryy*=(rad-wlen);
            alpha=getangle(world->player.PositionX-0.5,world->player.PositionY-0.5);
        }
        double xx,yy;
           xx=-sin(alpha);
		   yy=cos(alpha);
        
        double vecx=xx+trxx*4;
        double vecy=yy+tryy*4;        
        norm(vecx,vecy);
        double zekx=0,zeky=0;
        int lag=0;
        int tmon=0;
		for ( int j = 0; j < world->MAXMONSTERS; j++)
			if (world->monsters[j].ClassName >= 0) {
			    tmon++;
			    double tekx=world->monsters[j].PositionX - world->player.PositionX;
			    double teky=world->monsters[j].PositionY - world->player.PositionY;
			    double tlen=tekx*tekx+teky*teky;
			    if (tlen<0.20) {
			     if (tlen>0) {
			         tekx/=tlen*tlen;
			         teky/=tlen*tlen;
			     }			    
				 zekx-=tekx;
				 zeky-=teky;
				 lag++;
			    }			    			
			}
        norm(zekx,zeky);
        double runx=zekx*0.6+vecx;
        double runy=zeky*0.6+vecy;
        if ((world->player.PositionX<0.01)&&(runx<0)) runx=0;
        if ((world->player.PositionX>0.99)&&(runx>0)) runx=0;
        if ((world->player.PositionY<0.01)&&(runy<0)) runy=0;
        if ((world->player.PositionY>0.99)&&(runy>0)) runy=0;
        norm(runx,runy);
		world->run(runx,runy);
		int bj=-1;
		int insector=-1;
		double blen=0;
		for ( int j = 0; j < world->MAXMONSTERS; j++)
			if (world->monsters[j].ClassName > 0) {
			    double vx=world->monsters[j].PositionX - world->player.PositionX;
			    double vy=world->monsters[j].PositionY - world->player.PositionY;
			    double len=sqrt(vx*vx+vy*vy);
			    double ang=getangle(vx,vy);
				int tinsector=((((ang<pi/12)||(ang>2*pi-pi/12))&&(len<0.1))?1:0);
		        if (((tinsector>=insector)&&(len<blen))||(tinsector>insector)){
		            insector=tinsector;
		            blen=len;
		            bj=j;
		        }
			}
			int hua=0,hud=0;
            for ( int j = 0; j < world->MAXMONSTERS; j++)
			if (world->monsters[j].ClassName >= 0) 
            {
                if (world->monsters[j].BulletDamage>0) hua++; else hud++;
			}
			if (hua>hud*2) {
			     printf("shooters %d %d\n",hua,hud);
			     if ((world->player.PositionX<0.1)&&(radalpha>pi/2)&&(radalpha<3*pi/2)) radalpha=3*pi/2; else
			     if ((world->player.PositionX>0.9)&&(!(radalpha>pi/2)&&(radalpha<3*pi/2))) radalpha=pi/2;  else    
                 if ((world->player.PositionY<0.1)&&(radalpha>pi)) radalpha=0; else 
                 if ((world->player.PositionY>0.9)&&(radalpha<pi)) radalpha=pi; 
                 radalpha+=0.01;
                 if (radalpha>=2*pi) radalpha=0;
                 world->shoot(sin(radalpha),cos(radalpha));
                 bj=-1;
			}
        if ((insector==0)&&(blen>0.15)) {
            if (bj!=-1) {
                double hx=world->monsters[bj].PositionX - world->player.PositionX;
                double hy=world->monsters[bj].PositionY - world->player.PositionY;
                norm(hx,hy);
                double hhx=hx,hhy=hy;
                //hx=hx-hy/10;
               // hy=hy+hhx/10;
                world->shoot(hx,hy);
                bj=-1;
            }
        }
        if (bj!=-1) {
        world->shoot(world->monsters[bj].PositionX - world->player.PositionX,
						   world->monsters[bj].PositionY - world->player.PositionY);
        }
		//Choose the first monster that is still alive
	}

	return 0;
}
