unit simpleclass;
Interface
Type TCMissile = Record
	ClassName : Longint;
	PositionX : Single;
	PositionY : Single;
	VelocityX : Single;
	VelocityY : Single;
	Radius : Single;
	HitPoints : Single;
	MaxHitPoints : Single;
	Damage : Single;
end;

procedure ReadCMissileFromSocket(var m : TCMissile);
procedure WriteCMissileToSocket(var m : TCMissile);
Type TCPlayer = Record
	ClassName : Longint;
	PositionX : Single;
	PositionY : Single;
	VelocityX : Single;
	VelocityY : Single;
	Radius : Single;
	HitPoints : Single;
	MaxHitPoints : Single;
	MaxVelocity : Single;
	MaxAcceleration : Single;
	GunCooldownRemaining : Single;
	GunCooldownPeriod : Single;
	BulletDamage : Single;
	BulletHitPoints : Single;
	BulletVelocity : Single;
	BulletRadius : Single;
	ShootX : Single;
	ShootY : Single;
	RunX : Single;
	RunY : Single;
	Time : Longint;
end;

procedure ReadCPlayerFromSocket(var m : TCPlayer);
procedure WriteCPlayerToSocket(var m : TCPlayer);
Type TCMonster = Record
	ClassName : Longint;
	PositionX : Single;
	PositionY : Single;
	VelocityX : Single;
	VelocityY : Single;
	Radius : Single;
	HitPoints : Single;
	MaxHitPoints : Single;
	MaxVelocity : Single;
	MaxAcceleration : Single;
	GunCooldownRemaining : Single;
	GunCooldownPeriod : Single;
	BulletDamage : Single;
	BulletHitPoints : Single;
	BulletVelocity : Single;
	BulletRadius : Single;
	TeethCooldownRemaining : Single;
	TeethCooldownPeriod : Single;
	BiteDamage : Single;
end;

procedure ReadCMonsterFromSocket(var m : TCMonster);
procedure WriteCMonsterToSocket(var m : TCMonster);
Implementation

uses socketWrapper;

procedure ReadCMissileFromSocket(var m : TCMissile);
begin
	m.ClassName := nextInt;
	m.PositionX := nextFloat;
	m.PositionY := nextFloat;
	m.VelocityX := nextFloat;
	m.VelocityY := nextFloat;
	m.Radius := nextFloat;
	m.HitPoints := nextFloat;
	m.MaxHitPoints := nextFloat;
	m.Damage := nextFloat;
end;

procedure WriteCMissileToSocket(var m : TCMissile);
begin
	writeInt(m.ClassName);
	writeFloat(m.PositionX);
	writeFloat(m.PositionY);
	writeFloat(m.VelocityX);
	writeFloat(m.VelocityY);
	writeFloat(m.Radius);
	writeFloat(m.HitPoints);
	writeFloat(m.MaxHitPoints);
	writeFloat(m.Damage);
end;

procedure ReadCPlayerFromSocket(var m : TCPlayer);
begin
	m.ClassName := nextInt;
	m.PositionX := nextFloat;
	m.PositionY := nextFloat;
	m.VelocityX := nextFloat;
	m.VelocityY := nextFloat;
	m.Radius := nextFloat;
	m.HitPoints := nextFloat;
	m.MaxHitPoints := nextFloat;
	m.MaxVelocity := nextFloat;
	m.MaxAcceleration := nextFloat;
	m.GunCooldownRemaining := nextFloat;
	m.GunCooldownPeriod := nextFloat;
	m.BulletDamage := nextFloat;
	m.BulletHitPoints := nextFloat;
	m.BulletVelocity := nextFloat;
	m.BulletRadius := nextFloat;
	m.ShootX := nextFloat;
	m.ShootY := nextFloat;
	m.RunX := nextFloat;
	m.RunY := nextFloat;
	m.Time := nextInt;
end;

procedure WriteCPlayerToSocket(var m : TCPlayer);
begin
	writeInt(m.ClassName);
	writeFloat(m.PositionX);
	writeFloat(m.PositionY);
	writeFloat(m.VelocityX);
	writeFloat(m.VelocityY);
	writeFloat(m.Radius);
	writeFloat(m.HitPoints);
	writeFloat(m.MaxHitPoints);
	writeFloat(m.MaxVelocity);
	writeFloat(m.MaxAcceleration);
	writeFloat(m.GunCooldownRemaining);
	writeFloat(m.GunCooldownPeriod);
	writeFloat(m.BulletDamage);
	writeFloat(m.BulletHitPoints);
	writeFloat(m.BulletVelocity);
	writeFloat(m.BulletRadius);
	writeFloat(m.ShootX);
	writeFloat(m.ShootY);
	writeFloat(m.RunX);
	writeFloat(m.RunY);
	writeInt(m.Time);
end;

procedure ReadCMonsterFromSocket(var m : TCMonster);
begin
	m.ClassName := nextInt;
	m.PositionX := nextFloat;
	m.PositionY := nextFloat;
	m.VelocityX := nextFloat;
	m.VelocityY := nextFloat;
	m.Radius := nextFloat;
	m.HitPoints := nextFloat;
	m.MaxHitPoints := nextFloat;
	m.MaxVelocity := nextFloat;
	m.MaxAcceleration := nextFloat;
	m.GunCooldownRemaining := nextFloat;
	m.GunCooldownPeriod := nextFloat;
	m.BulletDamage := nextFloat;
	m.BulletHitPoints := nextFloat;
	m.BulletVelocity := nextFloat;
	m.BulletRadius := nextFloat;
	m.TeethCooldownRemaining := nextFloat;
	m.TeethCooldownPeriod := nextFloat;
	m.BiteDamage := nextFloat;
end;

procedure WriteCMonsterToSocket(var m : TCMonster);
begin
	writeInt(m.ClassName);
	writeFloat(m.PositionX);
	writeFloat(m.PositionY);
	writeFloat(m.VelocityX);
	writeFloat(m.VelocityY);
	writeFloat(m.Radius);
	writeFloat(m.HitPoints);
	writeFloat(m.MaxHitPoints);
	writeFloat(m.MaxVelocity);
	writeFloat(m.MaxAcceleration);
	writeFloat(m.GunCooldownRemaining);
	writeFloat(m.GunCooldownPeriod);
	writeFloat(m.BulletDamage);
	writeFloat(m.BulletHitPoints);
	writeFloat(m.BulletVelocity);
	writeFloat(m.BulletRadius);
	writeFloat(m.TeethCooldownRemaining);
	writeFloat(m.TeethCooldownPeriod);
	writeFloat(m.BiteDamage);
end;

begin
end.
