import java.io.IOException;
class Task {
	public static void main(String[] args) throws IOException{

		//Check for enough parameters
		if (args.length < 2){
			System.err.println("parameters: IP port");
			System.exit(10);
		}

		//Create the world data (and establish connection with the server)
		World world = new World(args[0], Integer.parseInt(args[1]));
		float alpha = (float)0.0;

		//Infinite loop
		while (true){
			//Send our turn and receive the update of the game world
			world.makeMove();

			//Print some information
			System.out.println("frame : " + world.player.Time + " HP: "+ world.player.HitPoints + " x: " + world.player.PositionX + " y: " + world.player.PositionY); 

			alpha += 0.02;
			//Run in circles (set direction)
			world.run((float)Math.cos(alpha), (float)Math.sin(alpha)); 

			//Choose the first monster that is still alive
			for ( int j = 0; j < world.MAXMONSTERS; j++) 
				if (world.monsters[j].ClassName > 0.){
				//Shoot the bastard! (Shoot in the direction of the monster)
					world.shoot(world.monsters[j].PositionX - world.player.PositionX, world.monsters[j].PositionY - world.player.PositionY); 
					break;
				}
		}
	}
}
