#ifndef GEOMETRY_OBJECTS_105878
#define GEOMETRY_OBJECTS_105878

#include "Global.h"

//All objects are points or circles
//They move over time

struct MovingCircle {
	double2 st, end;
	double rad;

	inline MovingCircle() {}
	inline MovingCircle(double2 _st, double2 _end, double _rad)
		 : st(_st), end(_end), rad(_rad) {}
};

double2 RandomVector();
double2 RandomDirection();
double2 LimitVectorNorm(double2 vect, double maxnorm);
double2 ForceVectorNorm(double2 vect, double norm);

bool InField(double2 pos);
void ForceToField(double2 &pos, double radius);

std::vector<int2> GetGridCells(const MovingCircle &circle);
bool HasIntersection(const MovingCircle &a, const MovingCircle &b);

double2 ShootMovingTarget(double2 pos, double2 vel, double speed);

#endif
